<html>
<head>
<title>OgreResourceManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreResourceManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreResourceManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _ResourceManager_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _ResourceManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreResourceGroupManager_8h.html">OgreResourceGroupManager.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreScriptLoader_8h.html">OgreScriptLoader.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Ogre {
<a name="l00042"></a>00042 
<a name="l00073"></a><a class="code" href="classOgre_1_1ResourceManager.html">00073</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ScriptLoader.html" title="Abstract class defining the interface used by classes which wish to perform script loading to define ...">ScriptLoader</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAlloc</a>
<a name="l00074"></a>00074     {
<a name="l00075"></a>00075     <span class="keyword">public</span>:
<a name="l00076"></a>00076         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a> <span class="comment">// public to allow external locking</span>
<a name="l00077"></a>00077         <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>();
<a name="l00078"></a>00078         <span class="keyword">virtual</span> ~ResourceManager();
<a name="l00079"></a>00079 
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> create(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, 
<a name="l00100"></a>00100             <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0, 
<a name="l00101"></a>00101             <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* createParams = 0);
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="classOgre_1_1ResourceManager.html#af484f2b60c8d9bc87f37fa8af8e630c5">00103</a>         <span class="keyword">typedef</span> std::pair&lt;ResourcePtr, bool&gt; <a class="code" href="classOgre_1_1ResourceManager.html#af484f2b60c8d9bc87f37fa8af8e630c5">ResourceCreateOrRetrieveResult</a>;
<a name="l00117"></a>00117         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ResourceManager.html#af484f2b60c8d9bc87f37fa8af8e630c5">ResourceCreateOrRetrieveResult</a> createOrRetrieve(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00118"></a>00118             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, 
<a name="l00119"></a>00119             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0, 
<a name="l00120"></a>00120             <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* createParams = 0);
<a name="l00121"></a>00121         
<a name="l00129"></a>00129         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMemoryBudget( <span class="keywordtype">size_t</span> bytes);
<a name="l00130"></a>00130 
<a name="l00133"></a>00133         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getMemoryBudget(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00134"></a>00134 
<a name="l00136"></a><a class="code" href="classOgre_1_1ResourceManager.html#a0458e4665975faed7311b05879dfac2f">00136</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ResourceManager.html#a0458e4665975faed7311b05879dfac2f" title="Gets the current memory usage, in bytes.">getMemoryUsage</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMemoryUsage.get(); }
<a name="l00137"></a>00137 
<a name="l00144"></a>00144         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unload(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00145"></a>00145         
<a name="l00152"></a>00152         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unload(<a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle);
<a name="l00153"></a>00153 
<a name="l00166"></a>00166         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadAll(<span class="keywordtype">bool</span> reloadableOnly = <span class="keyword">true</span>);
<a name="l00167"></a>00167 
<a name="l00179"></a>00179         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reloadAll(<span class="keywordtype">bool</span> reloadableOnly = <span class="keyword">true</span>);
<a name="l00180"></a>00180 
<a name="l00195"></a>00195         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unloadUnreferencedResources(<span class="keywordtype">bool</span> reloadableOnly = <span class="keyword">true</span>);
<a name="l00196"></a>00196 
<a name="l00210"></a>00210         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reloadUnreferencedResources(<span class="keywordtype">bool</span> reloadableOnly = <span class="keyword">true</span>);
<a name="l00211"></a>00211 
<a name="l00229"></a>00229         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">remove</span>(<a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r);
<a name="l00230"></a>00230 
<a name="l00248"></a>00248         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">remove</span>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00249"></a>00249         
<a name="l00267"></a>00267         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">remove</span>(<a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle);
<a name="l00282"></a>00282         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAll(<span class="keywordtype">void</span>);
<a name="l00283"></a>00283 
<a name="l00298"></a>00298         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeUnreferencedResources(<span class="keywordtype">bool</span> reloadableOnly = <span class="keyword">true</span>);
<a name="l00299"></a>00299 
<a name="l00302"></a>00302         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> getByName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#a70da3137e703c147b98fbfbbebfbf023" title="Special resource group name which causes resource group to be automatically determined based on searc...">ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME</a>);
<a name="l00305"></a>00305         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> getByHandle(<a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle);
<a name="l00306"></a>00306         
<a name="l00308"></a><a class="code" href="classOgre_1_1ResourceManager.html#a9dcc9da5760fcd3b39b4566fe308ad6b">00308</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> resourceExists(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name)
<a name="l00309"></a>00309         {
<a name="l00310"></a>00310             <span class="keywordflow">return</span> !getByName(name).isNull();
<a name="l00311"></a>00311         }
<a name="l00313"></a><a class="code" href="classOgre_1_1ResourceManager.html#ad9b4efbeacb17f07710c30bd5048e42f">00313</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> resourceExists(<a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle)
<a name="l00314"></a>00314         {
<a name="l00315"></a>00315             <span class="keywordflow">return</span> !getByHandle(handle).isNull();
<a name="l00316"></a>00316         }
<a name="l00317"></a>00317 
<a name="l00321"></a>00321         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyResourceTouched(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* res);
<a name="l00322"></a>00322 
<a name="l00326"></a>00326         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyResourceLoaded(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* res);
<a name="l00327"></a>00327 
<a name="l00331"></a>00331         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyResourceUnloaded(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* res);
<a name="l00332"></a>00332 
<a name="l00348"></a>00348         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> prepare(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00349"></a>00349             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, 
<a name="l00350"></a>00350             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* loadParams = 0,
<a name="l00351"></a>00351             <span class="keywordtype">bool</span> backgroundThread = <span class="keyword">false</span>);
<a name="l00352"></a>00352 
<a name="l00368"></a>00368         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> load(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00369"></a>00369             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, 
<a name="l00370"></a>00370             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* loadParams = 0,
<a name="l00371"></a>00371             <span class="keywordtype">bool</span> backgroundThread = <span class="keyword">false</span>);
<a name="l00372"></a>00372 
<a name="l00388"></a><a class="code" href="classOgre_1_1ResourceManager.html#a37ec0e845f49b7f7e3dc868456ced1e8">00388</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; <a class="code" href="classOgre_1_1ResourceManager.html#a37ec0e845f49b7f7e3dc868456ced1e8" title="Gets the file patterns which should be used to find scripts for this ResourceManager.">getScriptPatterns</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mScriptPatterns; }
<a name="l00389"></a>00389 
<a name="l00403"></a><a class="code" href="classOgre_1_1ResourceManager.html#a8240f6bbf3449b1f2acdd476efbde821">00403</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> parseScript(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName)
<a name="l00404"></a>00404                 { (void)stream; (void)groupName; }
<a name="l00405"></a>00405 
<a name="l00412"></a><a class="code" href="classOgre_1_1ResourceManager.html#a917b69fbaf300dcb0488d14d357296df">00412</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1ResourceManager.html#a917b69fbaf300dcb0488d14d357296df" title="Gets the relative loading order of resources of this type.">getLoadingOrder</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLoadOrder; }
<a name="l00413"></a>00413 
<a name="l00415"></a><a class="code" href="classOgre_1_1ResourceManager.html#a4a16604e10cd71957fcce705dead9a2c">00415</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1ResourceManager.html#a4a16604e10cd71957fcce705dead9a2c" title="Gets a string identifying the type of resource this manager handles.">getResourceType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mResourceType; }
<a name="l00416"></a>00416 
<a name="l00418"></a><a class="code" href="classOgre_1_1ResourceManager.html#aa3ff9558e8fa8187f510472a58093b6f">00418</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ResourceManager.html#aa3ff9558e8fa8187f510472a58093b6f" title="Sets whether this manager and its resources habitually produce log output.">setVerbose</a>(<span class="keywordtype">bool</span> v) { mVerbose = v; }
<a name="l00419"></a>00419 
<a name="l00421"></a><a class="code" href="classOgre_1_1ResourceManager.html#af96b58b31c152a8ae3c6152ee3ea12e7">00421</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ResourceManager.html#af96b58b31c152a8ae3c6152ee3ea12e7" title="Gets whether this manager and its resources habitually produce log output.">getVerbose</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mVerbose; }
<a name="l00422"></a>00422 
<a name="l00429"></a><a class="code" href="classOgre_1_1ResourceManager_1_1ResourcePool.html">00429</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceManager_1_1ResourcePool.html" title="Definition of a pool of resources, which users can use to reuse similar resources many times without ...">ResourcePool</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Pool.html" title="Template class describing a simple pool of items.">Pool</a>&lt;ResourcePtr&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAlloc</a>
<a name="l00430"></a>00430         {
<a name="l00431"></a>00431         <span class="keyword">protected</span>:
<a name="l00432"></a><a class="code" href="classOgre_1_1ResourceManager_1_1ResourcePool.html#a01e1418ca8b8d16015de63db8fc2646c">00432</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ResourceManager_1_1ResourcePool.html#a01e1418ca8b8d16015de63db8fc2646c">mName</a>;
<a name="l00433"></a>00433         <span class="keyword">public</span>:
<a name="l00434"></a>00434             <a class="code" href="classOgre_1_1ResourceManager_1_1ResourcePool.html" title="Definition of a pool of resources, which users can use to reuse similar resources many times without ...">ResourcePool</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00435"></a>00435             ~<a class="code" href="classOgre_1_1ResourceManager_1_1ResourcePool.html" title="Definition of a pool of resources, which users can use to reuse similar resources many times without ...">ResourcePool</a>();
<a name="l00437"></a>00437             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName() <span class="keyword">const</span>;
<a name="l00438"></a>00438             <span class="keywordtype">void</span> clear();
<a name="l00439"></a>00439         };
<a name="l00440"></a>00440         
<a name="l00442"></a>00442         <a class="code" href="classOgre_1_1ResourceManager_1_1ResourcePool.html" title="Definition of a pool of resources, which users can use to reuse similar resources many times without ...">ResourcePool</a>* getResourcePool(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00444"></a>00444         <span class="keywordtype">void</span> destroyResourcePool(<a class="code" href="classOgre_1_1ResourceManager_1_1ResourcePool.html" title="Definition of a pool of resources, which users can use to reuse similar resources many times without ...">ResourcePool</a>* pool);
<a name="l00446"></a>00446         <span class="keywordtype">void</span> destroyResourcePool(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00448"></a>00448         <span class="keywordtype">void</span> destroyAllResourcePools();
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453     <span class="keyword">protected</span>:
<a name="l00454"></a>00454 
<a name="l00456"></a>00456         <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> getNextHandle(<span class="keywordtype">void</span>);
<a name="l00457"></a>00457 
<a name="l00479"></a>00479         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* createImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle, 
<a name="l00480"></a>00480             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader, 
<a name="l00481"></a>00481             <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* createParams) = 0;
<a name="l00483"></a>00483         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addImpl( <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; res );
<a name="l00485"></a>00485         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeImpl( <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; res );
<a name="l00488"></a>00488         <span class="keyword">virtual</span> <span class="keywordtype">void</span> checkUsage(<span class="keywordtype">void</span>);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a>00491     <span class="keyword">public</span>:
<a name="l00492"></a><a class="code" href="classOgre_1_1ResourceManager.html#a60ea46f69b1dd9c8e27b9b3d7bd5bc35">00492</a>         <span class="keyword">typedef</span> HashMap&lt; String, ResourcePtr &gt; <a class="code" href="classOgre_1_1ResourceManager.html#a60ea46f69b1dd9c8e27b9b3d7bd5bc35">ResourceMap</a>;
<a name="l00493"></a><a class="code" href="classOgre_1_1ResourceManager.html#af1a46e6268002377bc95d3721d21aa92">00493</a>         <span class="keyword">typedef</span> HashMap&lt; String, ResourceMap &gt; <a class="code" href="classOgre_1_1ResourceManager.html#af1a46e6268002377bc95d3721d21aa92">ResourceWithGroupMap</a>;
<a name="l00494"></a><a class="code" href="classOgre_1_1ResourceManager.html#af6b68646abe6e9959072c1ece458ee55">00494</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;ResourceHandle, ResourcePtr&gt;::type</a> <a class="code" href="classOgre_1_1ResourceManager.html#af6b68646abe6e9959072c1ece458ee55">ResourceHandleMap</a>;
<a name="l00495"></a>00495     <span class="keyword">protected</span>:
<a name="l00496"></a><a class="code" href="classOgre_1_1ResourceManager.html#af7ac79c874e49fadc3cd7e228ab640d8">00496</a>         <a class="code" href="classOgre_1_1ResourceManager.html#af6b68646abe6e9959072c1ece458ee55">ResourceHandleMap</a> <a class="code" href="classOgre_1_1ResourceManager.html#af7ac79c874e49fadc3cd7e228ab640d8">mResourcesByHandle</a>;
<a name="l00497"></a><a class="code" href="classOgre_1_1ResourceManager.html#ac02278ff18455db85fa7473abad9688c">00497</a>         <a class="code" href="classOgre_1_1ResourceManager.html#a60ea46f69b1dd9c8e27b9b3d7bd5bc35">ResourceMap</a> <a class="code" href="classOgre_1_1ResourceManager.html#ac02278ff18455db85fa7473abad9688c">mResources</a>;
<a name="l00498"></a><a class="code" href="classOgre_1_1ResourceManager.html#a3ea8cebb67199e6050d992036f3b4f3c">00498</a>         <a class="code" href="classOgre_1_1ResourceManager.html#af1a46e6268002377bc95d3721d21aa92">ResourceWithGroupMap</a> <a class="code" href="classOgre_1_1ResourceManager.html#a3ea8cebb67199e6050d992036f3b4f3c">mResourcesWithGroup</a>;
<a name="l00499"></a><a class="code" href="classOgre_1_1ResourceManager.html#a70a84973505dc749acb913daef662f90">00499</a>         <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> <a class="code" href="classOgre_1_1ResourceManager.html#a70a84973505dc749acb913daef662f90">mNextHandle</a>;
<a name="l00500"></a><a class="code" href="classOgre_1_1ResourceManager.html#a7f0a00e183f455cdce1ec9152722f9b7">00500</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ResourceManager.html#a7f0a00e183f455cdce1ec9152722f9b7">mMemoryBudget</a>; <span class="comment">// In bytes</span>
<a name="l00501"></a><a class="code" href="classOgre_1_1ResourceManager.html#aaa9cfdfc994de65064ba2dbe08930de8">00501</a>         <a class="code" href="classOgre_1_1AtomicScalar.html">AtomicScalar&lt;size_t&gt;</a> <a class="code" href="classOgre_1_1ResourceManager.html#aaa9cfdfc994de65064ba2dbe08930de8">mMemoryUsage</a>; <span class="comment">// In bytes</span>
<a name="l00502"></a>00502 
<a name="l00503"></a><a class="code" href="classOgre_1_1ResourceManager.html#a5113f20b1db6ddfb51dba652f24cd0f0">00503</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ResourceManager.html#a5113f20b1db6ddfb51dba652f24cd0f0">mVerbose</a>;
<a name="l00504"></a>00504 
<a name="l00505"></a>00505         <span class="comment">// IMPORTANT - all subclasses must populate the fields below</span>
<a name="l00506"></a>00506 
<a name="l00508"></a><a class="code" href="classOgre_1_1ResourceManager.html#a450dcef1a87442bcfe848ff92c43c6b5">00508</a>         <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="code" href="classOgre_1_1ResourceManager.html#a450dcef1a87442bcfe848ff92c43c6b5" title="Patterns to use to look for scripts if supported (e.g. *.overlay)">mScriptPatterns</a>; 
<a name="l00510"></a><a class="code" href="classOgre_1_1ResourceManager.html#ad26313df1d10e7953c90b7c37b373cf8">00510</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1ResourceManager.html#ad26313df1d10e7953c90b7c37b373cf8" title="Loading order relative to other managers, higher is later.">mLoadOrder</a>; 
<a name="l00512"></a><a class="code" href="classOgre_1_1ResourceManager.html#a86f8c21e087cb00a62d677ef1cd8131d">00512</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ResourceManager.html#a86f8c21e087cb00a62d677ef1cd8131d" title="String identifying the resource type this manager handles.">mResourceType</a>; 
<a name="l00513"></a>00513 
<a name="l00514"></a>00514     <span class="keyword">public</span>:
<a name="l00515"></a><a class="code" href="classOgre_1_1ResourceManager.html#a4f7da59507a5a8550ea97615ff9afff0">00515</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;ResourceHandleMap&gt;</a> <a class="code" href="classOgre_1_1ResourceManager.html#a4f7da59507a5a8550ea97615ff9afff0">ResourceMapIterator</a>;
<a name="l00520"></a><a class="code" href="classOgre_1_1ResourceManager.html#a4d3289d4636168230da11c1c9794db59">00520</a>         <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">ResourceMapIterator</a> getResourceIterator(<span class="keywordtype">void</span>) 
<a name="l00521"></a>00521         {
<a name="l00522"></a>00522             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">ResourceMapIterator</a>(mResourcesByHandle.begin(), mResourcesByHandle.end());
<a name="l00523"></a>00523         }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525     <span class="keyword">protected</span>:
<a name="l00526"></a><a class="code" href="classOgre_1_1ResourceManager.html#a87899e8bec2f60ef1448d716a20db8e1">00526</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, ResourcePool*&gt;::type</a> <a class="code" href="classOgre_1_1ResourceManager.html#a87899e8bec2f60ef1448d716a20db8e1">ResourcePoolMap</a>;
<a name="l00527"></a><a class="code" href="classOgre_1_1ResourceManager.html#a00f151b76015e7e46cdb228cc3eaa53e">00527</a>         <a class="code" href="classOgre_1_1ResourceManager.html#a87899e8bec2f60ef1448d716a20db8e1">ResourcePoolMap</a> <a class="code" href="classOgre_1_1ResourceManager.html#a00f151b76015e7e46cdb228cc3eaa53e">mResourcePoolMap</a>;
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530     
<a name="l00531"></a>00531 
<a name="l00532"></a>00532     };
<a name="l00536"></a>00536 }
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
